; i4004em Version 0.2.0 - Intel 4004 emulator
; Copyright (C) 2001  dondalah@ripco.com (Dondalah)

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 ; 4004 test suite
 org 0h
 ; The 4004 starts at location 0
 jun 100h
 org 100h
 ; insert jms instruction here
 jun 0fffh
instruction_jcn:
 nop
 ldm 15
 jcn t,test
 nop
 jcn nt,test
 nop
test:
 ldm 0
 jcn nz,abc
 ldm 15
 jcn z,abc
 fim r0r1,076h
 fim r2r3,0feh
 inc r2
 jcn nc,abc
 inc r3
 jcn c,abc
 bbl 0
instruction_jms:
 ldm 1
 jms subrtn1
 jun 0fffh
subrtn1:
 jms subrtn2
 bbl 15
subrtn2:
 jms subrtn3
 bbl 14
subrtn3:
 ; jms subrtn4 ; stack overflow
 bbl 13
subrtn4:
 bbl 12
abc:
 nop
instruction_isz:
 fim r2r3,0fdh
iszloop:
 isz r3,iszloop
 bbl 0
instruction_add:
 fim r2r3,0feh
 ldm 5
 add r3
 fim r2r3,034h
 ldm 5
 add r3
 bbl 0
instruction_sub:
 fim r2r3,0feh
 ldm 5
 sub r3
 fim r2r3,034h
 ldm 5
 sub r3
 bbl 0
instruction_ld:
 fim r2r3,0feh
 ld r3
 fim r4r5,034h
 ld r4
 bbl 0
instruction_xch:
 fim r2r3,0feh
 ldm 1
 xch r3
 xch r3
 fim r4r5,034h
 ldm 12
 xch r4
 xch r4
 bbl 0
instruction_wrm_rdm:
 fim r2r3,076h
 src r2r3
 ldm 11
 wrm
 ldm 3
 rdm
 bbl 0
instruction_wmp_wrr:
 fim r2r3,0cdh
 src r2r3
 ldm 11
 wmp
 fim r2r3,076h
 src r2r3
 ldm 11
 wrr
 bbl 0
instruction_wr0_rd0:
 ldm 1
 wr0
 ldm 2
 wr1
 ldm 3
 wr2
 ldm 4
 wr3
 rd0
 rd1
 rd2
 rd3
 bbl 0
instruction_sbm:
 fim r2r3,076h
 src r2r3
 ldm 11
 wrm
 ldm 5
 sbm
 ldm 3
 wrm
 sbm
 sbm
 sbm
 bbl 0
instruction_rdr:
 fim r2r3,076h
 src r2r3
 ldm 11
 rdr
 bbl 0
instruction_adm:
 fim r2r3,076h
 src r2r3
 ldm 11
 wrm
 ldm 5
 adm
 ldm 3
 wrm
 adm
 adm
 adm
 bbl 0
instruction_accum_carry:
 ldm 0
 dac
 iac
 dac
 clb
 iac
 dac
 stc
 clc
 stc
 cmc
 cmc
 cma
 cma
 ral
 ral
 ral
 ral
 rar
 rar
 rar
 rar
 ldm 10
 ral
 ral
 ral
 ral
 ral
 rar
 rar
 rar
 rar
 rar
 bbl 0
instruction_tcc_daa_kbp_dcl:
 ldm 12
 stc
 tcc
 tcs
 ldm 12
 stc
 tcs
 ldm 12
 daa
 ldm 0
 kbp
 ldm 1
 kbp
 ldm 2
 kbp
 ldm 3
 kbp
 ldm 4
 kbp
 ldm 5
 kbp
 ldm 6
 kbp
 ldm 7
 kbp
 ldm 8
 kbp
 ldm 9
 kbp
 dcl
 bbl 0
 end
